#include "fahrstuhl.h"
#include <iostream>

Fahrstuhl::Fahrstuhl() : aktuelleEtage(0), zielEtage(0) {}

void Fahrstuhl::hoch() {}

void Fahrstuhl::links() {}

void Fahrstuhl::rechts() {}

void Fahrstuhl::runter() {}

void Fahrstuhl::bewegeFahrstuhl() {
    if (gewichtssensor.istRamenSchuesselErkannt()) {
        std::cout << "Gewicht erkannt. Der Fahrstuhl bewegt sich von Etage " << aktuelleEtage << " zu Etage " << zielEtage << "." << std::endl;
        aktuelleEtage = zielEtage; // Simuliere die Bewegung des Fahrstuhls zur Zieletage
        stoppeAnLichtsensoren(); // Überprüfen, ob der Fahrstuhl an Lichtsensoren stoppen muss
    } else {
        std::cout << "Kein ausreichendes Gewicht erkannt. Der Fahrstuhl bleibt auf Etage " << aktuelleEtage << "." << std::endl;
    }
}

void Fahrstuhl::setzeZielEtage(int etage) {
    zielEtage = etage;
}

void Fahrstuhl::fuegeLichtsensorHinzu(Lichtsensor* sensor) {
    lichtsensoren.push_back(sensor);
}

void Fahrstuhl::stoppeAnLichtsensoren() {
    for (Lichtsensor* sensor : lichtsensoren) {
        if (sensor->istLichtErkannt()) {
            std::cout << "Lichtsensor erkannt. Der Fahrstuhl stoppt an Etage " << aktuelleEtage << "." << std::endl;
        }
    }
}

int Fahrstuhl::getAktuelleEtage() const {
    return aktuelleEtage;
}

int Fahrstuhl::getZielEtage() const {
    return zielEtage;
}
