#pragma once

#include "gewichtssensor.h"
#include "lichtsensor.h"
#include <vector>

class Fahrstuhl
{
public:
    Fahrstuhl();
    void hoch();
    void rechts();
    void runter();
    void links();
    void bewegeFahrstuhl();
    void setzeZielEtage(int etage);
    void fuegeLichtsensorHinzu(Lichtsensor* sensor);
    void stoppeAnLichtsensoren();
    int getAktuelleEtage() const; // Neue Getter-Methode für aktuelleEtage
    int getZielEtage() const; // Neue Getter-Methode für zielEtage

private:
    int aktuelleEtage;
    int zielEtage;
    Gewichtssensor gewichtssensor;
    std::vector<Lichtsensor*> lichtsensoren;
    //void stoppeAnLichtsensoren();
};
