#include "tst_fahrstuhl.h"

void FahrstuhlTest::initTestCase() {
}

void FahrstuhlTest::cleanupTestCase() {
}

void FahrstuhlTest::init() {
    fahrstuhl = new Fahrstuhl();
}

void FahrstuhlTest::cleanup() {

    delete fahrstuhl;
}

void FahrstuhlTest::testBewegeFahrstuhl() {
    Lichtsensor* sensor = new Lichtsensor();
    sensor->setzeAktivierung(true);
    fahrstuhl->fuegeLichtsensorHinzu(sensor);
    fahrstuhl->setzeZielEtage(5);
    fahrstuhl->bewegeFahrstuhl();
    QCOMPARE(fahrstuhl->getAktuelleEtage(), 5);
}

void FahrstuhlTest::testSetzeZielEtage() {
    fahrstuhl->setzeZielEtage(3);
    QCOMPARE(fahrstuhl->getZielEtage(), 3);
}

void FahrstuhlTest::testFuegeLichtsensorHinzu() {
    Lichtsensor* sensor = new Lichtsensor();
    fahrstuhl->fuegeLichtsensorHinzu(sensor);

}

QTEST_MAIN(FahrstuhlTest)



